var Irvine = new ActiveXObject('Irvine.Api');
var IrvineItem = new ActiveXObject('Irvine.Item');

function XMLHttpRequest()
{
	try {
		return new ActiveXObject('Msxml2.ServerXMLHTTP');
	} catch (e) {
		try {
			return new ActiveXObject('Msxml2.XMLHTTP');
		} catch (e) {
			return new ActiveXObject('Microsoft.XMLHTTP');
		}
	}
}

var http = XMLHttpRequest();

function base64decode(str)
{
	var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	var base64DecodeChars = new Array(
		-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
		-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
		-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
		52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
		-1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
		15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
		-1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
		41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1);
	
	var c1, c2, c3, c4;
	var i, len, out;
	
	len = str.length;
	i = 0;
	out = '';
	
	while(i < len) {
		/* c1 */
		do {
			c1 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
		} while(i < len && c1 == -1);
		if(c1 == -1)
			break;
		
		/* c2 */
		do {
			c2 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
		} while(i < len && c2 == -1);
		if(c2 == -1)
			break;
		
		out += String.fromCharCode((c1 << 2) | ((c2 & 0x30) >> 4));
		
		/* c3 */
		do {
			c3 = str.charCodeAt(i++) & 0xff;
			if(c3 == 61)
				return out;
			c3 = base64DecodeChars[c3];
		} while(i < len && c3 == -1);
		if(c3 == -1)
			break;
		
		out += String.fromCharCode(((c2 & 0XF) << 4) | ((c3 & 0x3C) >> 2));
		
		/* c4 */
		do {
			c4 = str.charCodeAt(i++) & 0xff;
			if(c4 == 61)
				return out;
			c4 = base64DecodeChars[c4];
		} while(i < len && c4 == -1);
		if(c4 == -1)
			break;
		
		out += String.fromCharCode(((c3 & 0x03) << 6) | c4);
	}
	return out;
}

var sbox = new Array(255);
var mykey = new Array(255);

function decrypt(src)
{
	var key = '72f27dae3d5ce9ceb803eaad50c3d657';
	var v3 = hexToChars(src);
	var v1 = strToChars(key);
	var v2 = calculate(v3, v1);
	return charsToStr(v2);
}

function initialize(pwd)
{
	var v2 = 0;
	var v3;
	var v4 = pwd.length;
	var v1 = 0;
	while (v1 <= 255) {
		mykey[v1] = pwd[v1 % v4];
		sbox[v1] = v1;
		++v1;
	}
	v1 = 0;
	while (v1 <= 255) {
		v2 = (v2 + sbox[v1] + mykey[v1]) % 256;
		v3 = sbox[v1];
		sbox[v1] = sbox[v2];
		sbox[v2] = v3;
		++v1;
	}
}

function calculate(plaintxt, psw)
{
	initialize(psw);
	var v1 = 0;
	var v2 = 0;
	var v9 = new Array();
	var v7;
	var v5;
	var v6;
	var v3 = 0;
	while (v3 < plaintxt.length) {
		v1 = (v1 + 1) % 256;
		v2 = (v2 + sbox[v1]) % 256;
		v5 = sbox[v1];
		sbox[v1] = sbox[v2];
		sbox[v2] = v5;
		var v4 = (sbox[v1] + sbox[v2]) % 256;
		v7 = sbox[v4];
		v6 = plaintxt[v3] ^ v7;
		v9.push(v6);
		++v3;
	}
	return v9;
}

function hexToChars(hex)
{
	var v3 = new Array();
	var v1 = (hex.substr(0, 2) == '0x') ? 2 : 0;
	while (v1 < hex.length) {
		v3.push(parseInt(hex.substr(v1, 2), 16));
		v1 += 2;
	}
	return v3;
}

function charsToStr(chars)
{
	var v3 = new String('');
	var v1 = 0;
	while (v1 < chars.length) {
		v3 += String.fromCharCode(chars[v1]);
		++v1;
	}
	return v3;
}

function strToChars(str)
{
	var v3 = new Array();
	var v1 = 0;
	while (v1 < str.length) {
		v3.push(str.charCodeAt(v1));
		++v1;
	}
	return v3;
}

function Download(url, title, href, cookie)
{
	IrvineItem.Url = url;
	IrvineItem.Filename = title;
	IrvineItem.Comment = href;
	
	if (!href.match('youku.com'))
		IrvineItem.Referer = href;
	
	if (WScript.Arguments.Unnamed.length > 1) {
		if (cookie) {
			IrvineItem.Cookie = WScript.Arguments.Unnamed.Item(1) + cookie;
		} else {
			IrvineItem.Cookie = WScript.Arguments.Unnamed.Item(1);
		}
	} else {
		if (cookie)
			IrvineItem.Cookie = cookie;
	}
	
	Irvine.Current.AddItem(IrvineItem);
}

function getUnknownVideo(href)
{
	if (href.match('yourfilehost\.com')) {
		var hosts = ['img.vid-dl.net',
			'your1.80code.com',
			'your2.vid-dl.net',
			'your3.vid-dl.net'];
		var nMin = 0;
		var nMax = 3;
		var nRandomInt = Math.floor(Math.random()*(nMax-nMin+1))+nMin;
		var host = hosts[nRandomInt];
	} else {
		var host = 'www.vid-dl.net';
	}
	
	var callback = '_jsonp_' +  (new Date).getTime() + '_1';
	var vid_dl = 'http://' + host + '/getUnknownVideo.php?url=' + encodeURIComponent(href) + '&callback=' + callback;
	http.open('GET', vid_dl, false);
	http.setRequestHeader('Referer', 'http://www.vid-dl.net/');
	http.send('');
	return eval(http.responseText.replace(callback, ''));
}

function getVideo(type, video_id)
{
	var callback = '_jsonp_' +  (new Date).getTime() + '_1';
	var vid_dl = 'http://www.vid-dl.net/getVideo.php?type=' + type + '&video_id=' + video_id + '&num=1&callback=' + callback;
	http.open('GET', vid_dl, false);
	http.setRequestHeader('Referer', 'http://www.vid-dl.net/');
	http.send('');
	return eval(http.responseText.replace(callback, ''));
}

function Vid_DL(type, url, title, href, ext)
{
	url = decodeURIComponent(url);
	
	if (type == 'Stage6') {
		title += '.divx';
	} else if (type == 'Yourfilehost') {
		
	} else if (type == 'Badongo' || type == 'Shooshtime') {
		title += '.wmv';
	} else {
		if (ext) {
			title += '.' + ext;
		} else {
			title += '.flv';
		}
	}
	
	Download(url, title, href, null);
}

function DL_Video(href)
{
	http.open('GET','http://www.dl-video.net/', false);
	http.send('');
	var sm = /<input type="hidden" name="sm" value="(.*?)" >/.exec(http.responseText)[1];
	var x = /<input type="hidden" name="x" id="x" value="(.*?)" >/.exec(http.responseText)[1];
	var sdurl = 'sdurl=' + encodeURIComponent(href) + '&sm=' + sm + '&x=' + x;
	WScript.Sleep(2000);
	http.open('POST','http://www.dl-video.net/', false);
	http.setRequestHeader('Referer', 'http://www.dl-video.net/');
	http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	http.send(sdurl);
	
	var matches = http.responseText.match(/VIDEO URL<\/a> <input readonly="readonly" value=".*?" .*? \/>.*?FILE NAME <input readonly="readonly" value=".*?" .*? \/>/g);
	
	if (matches) {
		for (var i=0;i<matches.length;i++) {
			var url = /VIDEO URL<\/a> <input readonly="readonly" value="(.*?)" .*? \/>/.exec(matches[i])[1];
			var title = /FILE NAME <input readonly="readonly" value="(.*?)" .*? \/>/.exec(matches[i])[1];
			if (title != 'error.flv') {
				Download(url, title, href, null);
			} else {
				return 0;
			}
		}
		return 1;
	} else {
		return 0;
	}
}

function Nicovideo(href)
{
	http.open('GET', href, false);
	http.setRequestHeader('Referer', href);
	http.send('');
	var title = /<title>(.*)<\/title>/.exec(http.responseText)[1];
	title = title.slice(0, title.lastIndexOf(']jRjR(SP1)'));
	
	Download(href, title, href, null);
}

function NantokaDoga(href)
{
	if (WScript.Arguments.Unnamed.length > 1) {
		var cookie = WScript.Arguments.Unnamed.Item(1);
	}
	
	http.open('GET', href, false);
	if (cookie)
		http.setRequestHeader('Cookie', cookie);
	http.send('');
	
	cookie += /Set-Cookie: (pm=\w+;)/.exec(http.getAllResponseHeaders())[1];
	
	var title = /<div id="mov_title">(.*)<\/div>/.exec(http.responseText)[1];
	
	var player = /\.\/player\.swf\?mid=\w+&uid=.+&ttl=\d+&d=\w+/.exec(http.responseText)[0];
	var d = /&d=(\w+)/.exec(player)[1];
	var mid = /\?mid=(\w+)/.exec(player)[1];
	var xmlurl = 'http://mes.nantokadoga.com/getcomment_new.php?mid=' + mid + '&cnt=0';
	
	http.open('GET', xmlurl, false);
	http.send('');
	
	var file = /<documents file="(.*)">/.exec(http.responseText)[1];
	var url = base64decode(d) + '/getfile.php?f=' + file;
	
	Download(url, title, href, cookie);
}

function Any6(href)
{
	if (WScript.Arguments.Unnamed.length > 1) {
		var cookie = WScript.Arguments.Unnamed.Item(1);
	}
	
	http.open('GET', href, false);
	if (cookie)
		http.setRequestHeader('Cookie', cookie);
	http.send('');
	var title = /<h1>(.*)<\/h1>/.exec(http.responseText)[1];
	var n = /n=vl\d+/.exec(href)[0];
	http.open('POST', 'http://any6.jp/watch/getflv.php', false);
	if (cookie)
		http.setRequestHeader('Cookie', cookie);
	http.setRequestHeader('Referer', href);
	http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	http.send(n);
	var url = decodeURIComponent(/&video_path=(.+?)&/.exec(http.responseText)[1]);
	title += /\..{3}$/.exec(url)[0];
	
	cookie = 'vi_access3=movie_file_ok;vi_access7=movie_file_ok;';
	
	Download(url, title, href, cookie);
}

function ZoomeCircle(href)
{
	var xmlurl = /http:\/\/circle\.zoome\.jp\/(\w+)\/media\/(\d+)/.exec(href);
	xmlurl = 'http://circle.zoome.jp/' + xmlurl[1] + '/swf_media/' + xmlurl[2] + '/';
	
	try {
		var xml = new ActiveXObject('MSXML2.DOMDocument');
	} catch (e) {
		var xml = new ActiveXObject('Microsoft.XMLDOM');
	}
	
	xml.async = false;
	xml.load(xmlurl);
	
	var url = decrypt(xml.selectSingleNode('/media/property/url_movie').text);
	var title = decodeURIComponent(xml.selectSingleNode('/media/property/title').text);
	
	try {
		var h264_encode_stat = xml.selectSingleNode('/media/property/h264_encode_stat').text;
	} catch (e) {
		var h264_encode_stat = null;
	}
	
	if (h264_encode_stat == 'encoded') {
		url = url.replace('m1_1.flv', 'm1_1.mp4');
		title += '.mp4';
	} else {
		title += '.flv';
	}
	
	Download(url, title, href, null);
}

function ZoomeDiary(href)
{
	http.open('GET', href, false);
	http.send('');
	var xmlurl = decrypt(/baseDom=\w+&baseXML=(\w+)/.exec(http.responseText)[1]);
	
	try {
		var xml = new ActiveXObject('MSXML2.DOMDocument');
	} catch (e) {
		var xml = new ActiveXObject('Microsoft.XMLDOM');
	}
	
	xml.async = false;
	xml.load(xmlurl);
	
	var title = decodeURIComponent(xml.selectSingleNode('/user/property/title').text);
	
	try {
		var h264_encode_stat = xml.selectSingleNode('/user/property/h264_encode_stat').text;
	} catch (e) {
		var h264_encode_stat = null;
	}
	
	if (h264_encode_stat == 'encoded') {
		var url = xmlurl.replace('m1_1.xml', 'm1_1.mp4');
		title += '.mp4';
	} else {
		var url = xmlurl.replace('m1_1.xml', 'm1_1.flv');
		title += '.flv';
	}
	
	Download(url, title, href, null);
}

if (WScript.Arguments.Unnamed.length > 0) {
	var href = WScript.Arguments.Unnamed.Item(0);
	
	if (href.match('www\.nicovideo\.jp')) {
		Nicovideo(href);
	} else if (href.match('nantokadoga\.com')) {
		NantokaDoga(href);
	} else if (href.match('any6\.jp')) {
		Any6(href);
	} else if (href.match('circle\.zoome\.jp')) {
		ZoomeCircle(href);
	} else if (href.match('zoome\.jp')) {
		ZoomeDiary(href);
	} else {
		var success = DL_Video(href);
		
		if (!success) {
			var json = getUnknownVideo(href);
			var t = json.status;
			
			if (t == 'source') {
				Vid_DL(json.type, json.url, json.title, href, json.ext);
			} else if (t == 'page') {
				json = getVideo(json.data[0].type, json.data[0].video_id);
				Vid_DL(json.type, json.url, json.title, href, json.ext);
			} else if (t == 'error') {
				WScript.Echo(json.msg);
			}
		}
	}
}
